using Practics;
using Practics.Model;
using System.Data.SqlClient;

namespace MSTestUnitTests
{
    [TestClass]
    public class UnitTest1
    {
        //string absolutePathToDB = "C:\\Users\\admin\\\\3\\ \\ TechSphere\\Practics\\Project\\TheProgramForTheTechnicalSupportDepartment\\Practics\\";
        string absolutePathToDB = "F:\\CS\\TheProgramForTheTechnicalSupportDepartment\\Practics\\";
        Practics.Model.Model testModel;

        [TestInitialize]
        public void InitTests()
        {
            Practics.Model.Model.connectionString = "Data Source=(localdb)\\MSSQLLocalDB;AttachDbFilename=" + absolutePathToDB + "dbtechsphere.mdf;Integrated Security=True;Connect Timeout=30;Encrypt=False";
            testModel = Practics.Model.Model.ModelInstance;
        }


        [TestMethod, Priority(20)]
        public void TestStatusesTable()
        {
            
            Assert.AreNotEqual(0, testModel.DataTableStatuses.Rows.Count);

        }

        [TestMethod, Priority(30)]
        public void TestAdminTable()
        {

            Assert.AreNotEqual(0, testModel.DataTableAdmins.Rows.Count);

        }


        [TestMethod, Priority(40)]
        public void TestProblemTypesTable()
        {

            Assert.AreNotEqual(0, testModel.DataTableProblemTypes.Rows.Count);

        }

        [TestMethod, Priority(50)]
        public void TestProblems()
        {

            testModel.InitDataAdapterProblems();
            Assert.AreNotEqual(0, testModel.DataTableProblems.Rows.Count);

        }

        [TestMethod, Priority(60)]
        public void TestInsertProblem()
        {

            bool flag=testModel.AddProblemToDB(1001, "TestProblem", "TestPC", "TestDescribe", 0);
            Assert.IsTrue(flag);            
        }



        [TestMethod, Priority(70)]
        public void TestReports()
        {
            string result;
            bool flag = Model.ExportDataTableToCSV(testModel.DataTableProblems,"report.csv",out result);
            Assert.IsTrue(flag);
        }


        [TestMethod, Priority(80)]
        public void TestInsertNote()
        {

           Assert.IsTrue(testModel.InsertNote(0));
            
        }

        [TestMethod, Priority(90)]
        public void TestAdapterProblems()
        {
            Assert.IsNotNull(testModel.AdapterProblems);
        }


        [TestMethod, Priority(90)]
        public void TestLogin()
        {
            User user;
            Assert.IsTrue(testModel.Login("test@gmail.com", "Test123!@#", out user));
        }




        [TestMethod, Priority(10)]
        public void TestConnection()
        {
                
            Practics.Model.Model testModel = Practics.Model.Model.ModelInstance;               
            Assert.IsNotNull(testModel);
            

        }




    }
}